>From db8e7672be02f692db0d21df0f73b1594a1af7c0 Mon Sep 17 00:00:00 2001
From: Vlad Bespalov <vlad.botanic@gmail.com>
Date: Tue, 12 Feb 2019 04:25:09 -0500
Subject: [PATCH] user32: make LoadString[AW] patchable

Wine-Bug: https://bugs.winehq.org/show_bug.cgi?id=46626
Wine-Bug: https://bugs.winehq.org/show_bug.cgi?id=45199
Signed-off-by: Vlad Bespalov <vlad.botanic@gmail.com>
---
 dlls/user32/resource.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

diff --git a/dlls/user32/resource.c b/dlls/user32/resource.c
index 83442d85db..8dad3d53d5 100644
--- a/dlls/user32/resource.c
+++ b/dlls/user32/resource.c
@@ -19,6 +19,8 @@
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
  */
 
+#include "config.h"
+
 #include <stdarg.h>
 
 #include "windef.h"
@@ -234,7 +236,7 @@ BOOL WINAPI DestroyAcceleratorTable( HACCEL handle )
 /**********************************************************************
  *	LoadStringW		(USER32.@)
  */
-INT WINAPI LoadStringW( HINSTANCE instance, UINT resource_id,
+INT WINAPI DECLSPEC_HOTPATCH LoadStringW( HINSTANCE instance, UINT resource_id,
                             LPWSTR buffer, INT buflen )
 {
     HGLOBAL hmem;
@@ -289,7 +291,7 @@ INT WINAPI LoadStringW( HINSTANCE instance, UINT resource_id,
 /**********************************************************************
  *	LoadStringA	(USER32.@)
  */
-INT WINAPI LoadStringA( HINSTANCE instance, UINT resource_id, LPSTR buffer, INT buflen )
+INT WINAPI DECLSPEC_HOTPATCH LoadStringA( HINSTANCE instance, UINT resource_id, LPSTR buffer, INT buflen )
 {
     HGLOBAL hmem;
     HRSRC hrsrc;
-- 
2.20.1