diff -urN lostwages/templates/en/download.template new/templates/en/download.template
--- lostwages/templates/en/download.template	2004-05-04 16:19:57.000000000 +0100
+++ new/templates/en/download.template	2004-05-24 21:42:43.966797840 +0100
@@ -181,6 +181,165 @@
       By <a href="http://franksworld.net/index.html">Frank Hendriksen</a>.
     </td>
   </tr>
+  
+  <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/windows/ie/downloads/default.asp">Microsoft Internet Explorer</a></b> - 
+      Microsoft<sup>&reg;</sup> Internet Explorer to install and run many applications on wine. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+  <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=bf9a24f9-b5c5-48f4-8edd-cdf2d29a79d5&DisplayLang=en">Visual Basic 6.0 sp5 runtime libraries</a></b> - 
+      The Microsoft<sup>&reg;</sup> Virual Basic Runtime libraries, you'll need these libraries if you want to use Visual Basic programs with wine. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+  <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=cebbacd8-c094-4255-b702-de3bb768148f&DisplayLang=en">Microsoft<sup>&reg;</sup> Windows<sup>&reg;</sup> Installer for Windows<sup>&reg;</sup> 95, 98 and ME</a></b> - 
+      The Microsoft<sup>&reg;</sup> Windows<sup>&reg;</sup> Installer 2.0, use this version if you've set wine to emulate Windows<sup>&reg;</sup> 95, 98 or ME and you want to install a program that uses the Microsoft<sup>&reg;</sup> Windows<sup>&reg;</sup> Installer. These programs have a .msi extension. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+  <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=4b6140f9-2d36-4977-8fa1-6f8a0f5dca8f&DisplayLang=en">Microsoft<sup>&reg;</sup> Windows<sup>&reg;</sup> Installer for Windows<sup>&reg;</sup> NT 4.0 and 2000</a></b> - 
+      The Microsoft<sup>&reg;</sup> Windows<sup>&reg;</sup> Installer 2.0, use this version if you've set wine to emulate Windows<sup>&reg;</sup> NT 4.0 or 2000 and you want to install a program that uses the Microsoft<sup>&reg;</sup> Windows<sup>&reg;</sup> Installer. These programs have a .msi extension. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+  <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/downloads/details.aspx?familyid=d7a4de78-81a9-4db7-beb6-84ff99342172&displaylang=en">Microsoft<sup>&reg;</sup> DCOM 95</a></b> - 
+      This package contains many files needed to install various programs on wine. It supplys many dlls, and is needed to run some InstallShield<sup>&reg;</sup> installers. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+  <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=08b1ac1b-7a11-43e8-b59d-0867f9bdda66&DisplayLang=en">Microsoft<sup>&reg;</sup> DCOM 98</a></b> - 
+      This package contains many files needed to install various programs on wine. It supplys many dlls, and is needed to run some InstallShield<sup>&reg;</sup> installers. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+  <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=6f94d31a-d1e0-4658-a566-93af0d8d4a1e&displaylang=en">Microsoft<sup>&reg;</sup> Common Controls DLL (comctl32.dll)</a></b> - 
+      You can use the native version of this dll if you need to run a program that won't work with the builtin version. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+   <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=6ae02498-07e9-48f1-a5d6-dbfa18d37e0f&DisplayLang=en">Microsoft<sup>&reg;</sup> ShFolder DLL (shfolder.dll)</a></b> - 
+      You can use this native dll if you need to run a program that needs it. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+  <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=860ee43a-a843-462f-abb5-ff88ea5896f6&DisplayLang=en">Microsoft<sup>&reg;</sup> CAPICOM DLL (capicom.dll)</a></b> - 
+      You can use this native dll if you need to run a program that needs it. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+  <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=cd1fc4b2-0885-47f4-af45-7fd5e14db6c0&DisplayLang=en">Microsoft<sup>&reg;</sup> Dbghelp DLL (dbghelp.dll)</a></b> - 
+      You can use this native dll if you need to run a program that needs it. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+  <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=5d46afd4-da0c-4b8e-b202-374f3dfd3d5d&DisplayLang=en">Microsoft<sup>&reg;</sup> Performance Data Helper DLL (pdh.dll)</a></b> - 
+      You can use this native dll if you need to run a program that needs it. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+  <tr>
+    <td align=center bgcolor="#ffffff">
+      <a href="http://www.microsoft.com">
+        <img src="{$root}/images/distro/winedows.gif" 
+         width="50" height="50" alt="Microsoft Corporation" border="0">
+      </a>
+    </td>
+    <td align=left bgcolor="#ffffff">
+      <b><a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=5d46afd4-da0c-4b8e-b202-374f3dfd3d5d&DisplayLang=en">Microsoft<sup>&reg;</sup> HTML Help</a></b> - 
+      You can use the native version of HTML help, if for some reason the native one doesn't work for you. Please note that it's up to you to comply with Microsoft<sup>&reg;</sup> licensing.
+    </td>
+  </tr>
+  
+  
+  
 </table>
 
 <h1><a name="link2us"></a>Link to Us</h1>